#include <stdio.h>
#include <zephyr.h>
#include <device.h>
#include <init.h>
#include <pm/pm.h>
#include <pm/device.h>
#include "pm.h"
// #include "retained.h"
#include <hal/nrf_gpio.h>


/* Prevent deep sleep (system off) from being entered on long timeouts
 * or `K_FOREVER` due to the default residency policy.
 *
 * This has to be done before anything tries to sleep, which means
 * before the threading system starts up between PRE_KERNEL_2 and
 * POST_KERNEL.  Do it at the start of PRE_KERNEL_2.
 */
static int disable_ds_1(const struct device *dev)
{
	ARG_UNUSED(dev);
	// pm_constraint_set(PM_STATE_SOFT_OFF);// NCS1.9.99
	pm_policy_state_lock_get(PM_STATE_SOFT_OFF);// NCS2.0.0+
	return 0;
}
SYS_INIT(disable_ds_1, PRE_KERNEL_2, 0);

void go_system_off(void)
{
	printk("%s system off \n", CONFIG_BOARD);
	// Configure to generate PORT event (wakeup) on button 1 press.
	nrf_gpio_cfg_input(NRF_DT_GPIOS_TO_PSEL(DT_NODELABEL(button0), gpios),NRF_GPIO_PIN_PULLUP);
	nrf_gpio_cfg_sense_set(NRF_DT_GPIOS_TO_PSEL(DT_NODELABEL(button0), gpios),NRF_GPIO_PIN_SENSE_LOW);
	// // follow two line the same lash two line
	// nrf_gpio_cfg_input(NRF_DT_GPIOS_TO_PSEL(DT_ALIAS(sw0), gpios),NRF_GPIO_PIN_PULLUP);
	// nrf_gpio_cfg_sense_set(NRF_DT_GPIOS_TO_PSEL(DT_ALIAS(sw0), gpios),NRF_GPIO_PIN_SENSE_LOW);
	
	// nrf_gpio_cfg_input(DT_GPIO_PIN(DT_NODELABEL(batttery_chc), gpios),NRF_GPIO_PIN_PULLUP);
	// nrf_gpio_cfg_sense_set(DT_GPIO_PIN(DT_NODELABEL(batttery_chc), gpios),NRF_GPIO_PIN_SENSE_LOW);

	// pm_power_state_force(0u, (struct pm_state_info){PM_STATE_SOFT_OFF, 0, 0});//<1.9.99
	const struct pm_state_info si = {PM_STATE_SOFT_OFF, 0, 0};
	pm_state_force(0, &si);//1.9.99+
	k_msleep(100);
}

